/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/

#include "SysInfo.h"
#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")

extern "C" __declspec (dllexport) ISysInfo* CreateSysInfo(DWORD code)
{
	TIMECAPS tc;
	timeGetDevCaps(&tc,sizeof(TIMECAPS));
	timeBeginPeriod(tc.wPeriodMin);
	return new CSysInfo(code);
}

extern "C" __declspec (dllexport) void DestroySysInfo(ISysInfo* p)
{
	TIMECAPS tc;
	timeGetDevCaps(&tc,sizeof(TIMECAPS));
	timeEndPeriod(tc.wPeriodMin);
	delete (CSysInfo*)p;
}

char* CSysInfo::GetInfo( DWORD ID , char* s )
{
	if(ID >= CPU_BASE && ID < CPU_BASE + 0xFFF && CPU != NULL){
		return CPU->GetInfo( ID , s );
	}
	return "";
}

int	CSysInfo::SetData( DWORD ID , DWORD Data )
{
	if(ID >= CPU_BASE && ID < CPU_BASE + 0xFFF && CPU != NULL){
		return CPU->SetData( ID , Data );
	}
	return -1;
}

int	CSysInfo::GetData( DWORD ID , DWORD* pData )
{
	if(ID == SI_STATUS){
		*pData = gFlagStatus;
		return gFlagStatus;
	}
	// CPU UPDATE
	if(ID >= CPU_UPDATE_BASE && ID < CPU_UPDATE_BASE + 32)
	{
#ifdef _WIN32
		DWORD mask = 1 << (ID - CPU_UPDATE_BASE);
		// pData == TimerType
		if(CPU != NULL){
			CPU->Init( mask, *pData );
		}else{
			CPU = new CCpuInfo( mask );
		}
		*pData = 0;
#else if // for UNIX
		if(CPU != NULL){
			CPU->Init();
		}else{
			CPU = new CCpuInfo();
		}
#endif
		return 0;
	}
	if(ID >= CPU_BASE && ID < CPU_BASE + 0xFFF && CPU != NULL){
		return CPU->GetData( ID , pData );
	}

	*pData = -1;
	return -1;
}

int CSysInfo::GetString( DWORD ID , char* s )
{
	if(ID >= CPU_BASE && ID < CPU_BASE + 0xFFF && CPU != NULL){
		return CPU->GetString( ID , s );;
	}
	
	// CSysInfo //
	switch ( ID )
	{
		case	SI_VERSION:		strcpy(s,CPU_INFO_VERSION);	break;
		case	SI_DATE:		strcpy(s,CPU_INFO_DATE);	break;
		case	SI_AUTHOR:		strcpy(s,CPU_INFO_AUTHOR);	break;
				break;
		default:
			strcpy(s,"");
			return -1;
	}
	return 0;
}