/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/

#if !defined(AFX_CRYSTALCPUIDDLG_H__0EA235B8_265E_4CB3_8765_D4DC5A075721__INCLUDED_)
#define AFX_CRYSTALCPUIDDLG_H__0EA235B8_265E_4CB3_8765_D4DC5A075721__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../CpuInfo/CpuInfoID.h"
#include "../CpuInfo/ISysInfo.h"

#include "DibSection.h"

#include "RealTimeClockDlg.h"

class CRealTimeClockDlg;

/////////////////////////////////////////////////////////////////////////////
// CCrystalCPUIDDlg Dialog

class CCrystalCPUIDDlg : public CDialog
{
public:
	CCrystalCPUIDDlg(CWnd* pParent = NULL);
	~CCrystalCPUIDDlg();
	char CrystalCPUIDVersion[32];
	char m_ini[MAX_PATH];
	char m_path[MAX_PATH];
	int  CreateWallPaper(DWORD Mode,char* FileName,char* ResourceName,COLORREF Color,BOOL flagGray=FALSE);
	void Refresh(DWORD TimerType = 0);
	void TextCopy(DWORD type);
	void ImageCopy(DWORD type);
	void EndRealTimeClock();
	void ForceHideOriginalClock();

	DWORD m_Mask;

	CRealTimeClockDlg* m_RealTimeClockDlg;

	// SysInfo
	ISysInfo* SysInfo;
	HINSTANCE hSysInfoLib;
	BOOL ConnectSysInfo(DWORD Mode);
	BOOL DisconnectSysInfo();
	
	// DibSection
	CDibSection	Dib;

	// Bios Information
	BOOL m_IsWMI;
	CString m_BiosDate;
	CString m_BiosVersion;
	CString m_BiosManufacturer;
	CString m_BiosCaption;
	CString m_SmBiosVersion;
	CString m_SmBiosCaption;
	CString m_SystemManufacturer;
	CString m_SystemModel;
	CString m_MotherVersion;
	CString m_MotherProduct;
	CString m_MotherManufacturer;

// Dialog Data
	//{{AFX_DATA(CCrystalCPUIDDlg)
	enum { IDD = IDD_CRYSTALCPUID_DIALOG };
	CStatic	m_Yamhill;
	CStatic	m_LongHaul;
	CStatic	m_LongRun;
	CStatic	m_PowerNow;
	CStatic	m_SpeedStep;
	CStatic	m_CpuNameC;
	CStatic	m_ClockC;
	CComboBox	m_CPUSelectC;
	CStatic	m_SSE3C;
	CStatic	m_IA64C;
	CStatic	m_AA64C;
	CStatic	m_SSEC;
	CStatic	m_SSE2C;
	CStatic	m_MMXExC;
	CStatic	m_MMXC;
	CStatic	m_3DNowC;
	CStatic	m_3DNowExC;
	CStatic	m_HTC;
	CString	m_BrandID;
	CString	m_CacheL1ITU;
	CString	m_CacheL1ITUUnit;
	CString	m_Clock;
	CString	m_ClockOri;
	CString	m_CPUName;
	CString	m_CPUNumber;
	CString	m_DataRate;
	CString	m_ExFamily;
	CString	m_ExFamilyEx;
	CString	m_ExModel;
	CString	m_ExModelEx;
	CString	m_ExStepping;
	CString	m_Family;
	CString	m_FamilyEx;
	CString	m_L1DataCache;
	CString	m_L1ITUCache;
	CString	m_L2Cache;
	CString	m_L2CacheSpeed;
	CString	m_L2CacheSpeedMHz;
	CString	m_L3Cache;
	CString	m_Model;
	CString	m_ModelEx;
	CString	m_Multiplier;
	CString	m_MultiplierOri;
	CString	m_NameString;
	CString	m_OverClock;
	CString	m_Stepping;
	CString	m_SystemBus;
	CString	m_SystemBusOri;
	CString	m_SystemClock;
	CString	m_SystemClockOri;
	CString	m_VendorString;
	CString	m_HyperThreading;
	CString	m_Platform;
	CString	m_CPUType;
	CString	m_Apic;
	CString	m_CodeName;
	CString	m_OS;
	CString	m_ProcessRule;
	CString	m_Memory;
	CString	m_CurrentDate;
	CString	m_Signature;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CCrystalCPUIDDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV Support
	//}}AFX_VIRTUAL

protected:
	HICON m_hIcon;
	CString m_MSRInfo;
	BOOL m_FlagHideOriginalClock;
	HACCEL m_hAccelerator;
	CString m_TransmetaInfo;
	CString m_BiosInfo;

	BOOL BiosInfo();

	//{{AFX_MSG(CCrystalCPUIDDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnDestroy();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnSelchangeCpuSelect();
	afx_msg void OnExit();
	afx_msg void OnRefresh();
	afx_msg void OnCrystalDewWorld();
	afx_msg void OnCustomize();
	afx_msg void OnCpuInfoText();
	afx_msg void OnCrystalCpuidText();
	afx_msg void OnEnglish();
	afx_msg void OnJapanese();
	afx_msg void OnFeatureFlags();
	afx_msg void OnCpuidDetail();
	afx_msg void OnLicense();
	afx_msg void OnReadMe();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnLoveHammer();
	afx_msg void OnQueryPerformanceFrequency();
	afx_msg void OnCpuSupportCpuList();
	afx_msg void OnHideOriginalClock();
	afx_msg void OnSaveImage();
	afx_msg void OnPreviewText();
	afx_msg void OnCopyImage();
	afx_msg void OnCopyText();
	afx_msg void OnSaveText();
	afx_msg void OnQuickSaveImage();
	afx_msg void OnBiosInfo();
	afx_msg void OnTransmetaInfo();
	afx_msg void OnProcessorSerial();
	afx_msg void OnRealTimeClock();
	afx_msg void OnAbout();
	afx_msg void OnLongHaul();
	afx_msg void OnCacheInfo();
	afx_msg void OnRefreshMmt();
	afx_msg void OnRefreshQpc();
	afx_msg void OnRefreshWt();
	afx_msg void OnRefreshNoload();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}

#endif // !defined(AFX_CRYSTALCPUIDDLG_H__0EA235B8_265E_4CB3_8765_D4DC5A075721__INCLUDED_)
